************************ HD2FLOPY.PRG **************************
*
*   Program to break up a large .dbf for storing on floppies;
*
*   Assumptions: source dbIII file is in the current directory
*                and first target disk is formatted and empty.
*   A pause is allowed for formatting, but the number of disks
*   estimated as required is based on the free diskspace available
*   on the disk in the target drive at program start.
*   The program will in fact attempt to use all available space 
*   on any disk inserted; this will cause an error if you insert
*   a disk with larger capacity after starting with one with less.
*
*   note: resets default drive to C at conclusion.
*   acknowledgements: original program from Brown Bag BBS;
*   commenting by Michael Brockbank
*
SET TALK OFF
CLEAR
odbf=SPACE(30)                                  && Set space for filename
fdrive="A"                                      && Most targets drvs are a:
ndbf=SPACE(8)                                   && Set space for target
@ 1,0 SAY "Backup which database?" GET odbf     && Get source name,
@ 3,0 say "(.dbf assumed or add extension)"     && .dbf ext not required.
@ 5,0 SAY "To which floppy drive?" GET fdrive
@ 7,0 SAY "Enter Target filename:" GET ndbf     && Filename only; prg adds
@ 8,0 say "(without any extension)"             && counter as the extension 
READ
odbf=TRIM(odbf)                                 && Trim excess spaces
ndbf=TRIM(ndbf)
fmess="Insert a blank, formatted disk in ";     
     +"Drive &fdrive, and press a key..."       && Store program prompt to
*                                               && variable for recall
IF READKEY()=12
  RETURN
ENDIF
IF ndbf<=" "                                    && If no name for target file
  ? [No TARGET file]+CHR(7)                     && give user message
  RETURN                                        && and return.
ENDIF
IF FILE(odbf) .OR. FILE(odbf+".DBF")            && If the source filename
  USE &odbf                                     && exists open it.
ELSE                                            && If not give user msg.
  ? [No SOURCE file: "&odbf"]+CHR(7)            && and exit.
  RETURN
ENDIF
*                                               && Use variable to 
SET DEFAULT TO &fdrive                          && set drive for copy.
DO WHILE DISKSPACE()<1                          && Pause loop if disk in 
  WAIT fmess                                    && the target drive is full.
ENDDO

* Calc header size
STOR 0 TO fldno,header
DO WHILE ""<FIELD(fldno+1)                     && Loop thru all the fields
  fldno=fldno+1                                && and count them.
ENDDO
header=32*fldno+35                             && Mult. bytes x # of fields.

* Calc # of floppies needed                    && Based on current free space:
floprecs=INT((DISKSPACE()-header)/RECSIZE())   && divide space by record size
flopneed=INT((RECCOUNT())/floprecs)+1          && and record count by number
makeflop="F"                                   && of rec's that will fit
DO WHILE makeflop$"Ff"                         && onto current disk.
  ? STR(flopneed)+" Disks required.  "         && Result is estimated # disks.
  ?? "Press <ENTER> to proceed."               && Pause to allow formatting.
  WAIT "To format additional disks, insert ";
      +"floppy and press <F>" TO makeflop      && Get user's keypress
  IF makeflop$"Ff"                             && if an upper or lowercase F
    RUN FORMAT &fdrive:                        && use DOS command to format.
  ENDIF
ENDDO                                          && End of pause/format loop.

sofar="0"                                      && Initialize exten. variable.
DO WHILE .NOT. EOF()                           && Start of copying loop.
  SET TALK ON
  sofar=LTRIM(STR(VAL(sofar)+1))               && Increment the counter.
  COPY NEXT floprecs TO &ndbf..&sofar          && Form filename, add 
*                                              && counter as the extension &
*                                              && copy off as many as were
*                                              && cal'c to fit on initial
*                                              && target disk.
  SET TALK OFF                                 
  IF .NOT. EOF()                               && If not at the last record
    SKIP                                       && go to the following record
    DO WHILE DISKSPACE()<RECSIZE()+header      && and pause for disk insert.
      WAIT fmess                               && Give user message so long
    ENDDO                                      && as target disk is full.
  ENDIF
ENDDO
close all                                      && Close any open files and
SET DEFAULT TO C                               && reset default drive.
